      subroutine s2n_init_r16()
      implicit none!
      include 's2n_declare_r16.h'
      real*16 gf_gf

      pi = 4q0*atan(1q0)
      sr2 = sqrt(2q0)
      i_ = qcmplx(0q0,1q0)
      cfl = 1q0
      cfq = 3q0

      if (ichep.eq.1) then
         e   = 0.31345q0
         stw = 0.48076q0
         mz  = 91.1876q0
         wz  = 2.43631q0
         ww  = 2.02798q0
         mmo = 0.10566q0
         mta = 1.77699q0
         mch = 1.65q0
         mst = 0.177q0
         mtp = 174.3q0
         wtp = 1.54688q0
         mbt = 4.85q0
         mh  = 115q0
         wh  = 0.0061744q0
         stw2 = stw**2
         ctw2 = 1q0-stw2
         ctw  = sqrt(ctw2)
         mw  = mz*ctw
         alpha = e**2/4q0/pi
         alphai = 1q0/alpha
      endif

      qf( 1) =  0q0
      qf( 2) = -1q0
      qf( 3) =  0q0
      qf( 4) = -1q0
      qf( 5) =  0q0
      qf( 6) = -1q0
      qf( 7) =  2q0/3q0
      qf( 8) = -1q0/3q0
      qf( 9) =  2q0/3q0
      qf(10) = -1q0/3q0
      qf(11) =  2q0/3q0
      qf(12) = -1q0/3q0

      i3f( 1) =  .5q0
      i3f( 2) = -.5q0
      i3f( 3) =  .5q0
      i3f( 4) = -.5q0
      i3f( 5) =  .5q0
      i3f( 6) = -.5q0
      i3f( 7) =  .5q0
      i3f( 8) = -.5q0
      i3f( 9) =  .5q0
      i3f(10) = -.5q0
      i3f(11) =  .5q0
      i3f(12) = -.5q0

      ram2 = ma**2
      rvm2 = mv**2
      rhm2 = mh**2
      rzm2 = mz**2
      rwm2 = mw**2
      renm2 = men**2
      relm2 = mel**2
      rupm2 = mup**2
      rdnm2 = mdn**2
      rmnm2 = mmn**2
      rmom2 = mmo**2
      rchm2 = mch**2
      rstm2 = mst**2
      rtnm2 = mtn**2
      rtam2 = mta**2
      rtpm2 = mtp**2
      rbtm2 = mbt**2

      ctw2 = rwm2/rzm2
      stw2 = 1q0-ctw2
      ctw4 = ctw2**2
      stw4 = stw2**2
      ctw6 = ctw2**3
      stw6 = stw2**3
      ctw = mw/mz
      stw = sqrt(1q0-ctw2)

      rwz = ctw2
      rhz = rhm2/rzm2
      rhw = rhm2/rwm2
      renh = renm2/rhm2
      relh = relm2/rhm2
      ruph = rupm2/rhm2
      rdnh = rdnm2/rhm2
      rmnh = rmnm2/rhm2
      rmoh = rmom2/rhm2
      rchh = rchm2/rhm2
      rsth = rstm2/rhm2
      rtnh = rtnm2/rhm2
      rtah = rtam2/rhm2
      rtph = rtpm2/rhm2
      rbth = rbtm2/rhm2
      renz = renm2/rzm2
      relz = relm2/rzm2
      rupz = rupm2/rzm2
      rdnz = rdnm2/rzm2
      rmnz = rmnm2/rzm2
      rmoz = rmom2/rzm2
      rchz = rchm2/rzm2
      rstz = rstm2/rzm2
      rtnz = rtnm2/rzm2
      rtaz = rtam2/rzm2
      rtpz = rtpm2/rzm2
      rbtz = rbtm2/rzm2
      renw = renm2/rwm2
      relw = relm2/rwm2
      rupw = rupm2/rwm2
      rdnw = rdnm2/rwm2
      rmnw = rmnm2/rwm2
      rmow = rmom2/rwm2
      rchw = rchm2/rwm2
      rstw = rstm2/rwm2
      rtnw = rtnm2/rwm2
      rtaw = rtam2/rwm2
      rtpw = rtpm2/rwm2
      rbtw = rbtm2/rwm2

      cm2 = qcmplx(0q0, -1q-30)
      vm2 = qcmplx(rvm2,-1q-30)
      hm2 = qcmplx(rhm2,-1q-30)
      zm2 = qcmplx(rzm2,-1q-30)
      wm2 = qcmplx(rwm2,-1q-30)
      enm2 = qcmplx(renm2,-1q-30)
      elm2 = qcmplx(relm2,-1q-30)
      upm2 = qcmplx(rupm2,-1q-30)
      dnm2 = qcmplx(rdnm2,-1q-30)
      mnm2 = qcmplx(rmnm2,-1q-30)
      mom2 = qcmplx(rmom2,-1q-30)
      chm2 = qcmplx(rchm2,-1q-30)
      stm2 = qcmplx(rstm2,-1q-30)
      tnm2 = qcmplx(rtnm2,-1q-30)
      tam2 = qcmplx(rtam2,-1q-30)
      tpm2 = qcmplx(rtpm2,-1q-30)
      btm2 = qcmplx(rbtm2,-1q-30)

      qen = qf(1)
      qel = qf(2)
      qup = qf(7)
      qdn = qf(8)
      qmn = qf(3)
      qmo = qf(4)
      qch = qf(9)
      qst = qf(10)
      qtn = qf(5)
      qta = qf(6)
      qtp = qf(11)
      qbt = qf(12)

      aen = i3f(1)
      ael = i3f(2)
      aup = i3f(7)
      adn = i3f(8)
      amn = i3f(3)
      amo = i3f(4)
      ach = i3f(9)
      ast = i3f(10)
      atn = i3f(5)
      ata = i3f(6)
      atp = i3f(11)
      abt = i3f(12)

      ven = aen-2q0*qen*stw2
      vel = ael-2q0*qel*stw2
      vup = aup-2q0*qup*stw2
      vdn = adn-2q0*qdn*stw2
      vmn = amn-2q0*qmn*stw2
      vmo = amo-2q0*qmo*stw2
      vch = ach-2q0*qch*stw2
      vst = ast-2q0*qst*stw2
      vtn = atn-2q0*qtn*stw2
      vta = ata-2q0*qta*stw2
      vtp = atp-2q0*qtp*stw2
      vbt = abt-2q0*qbt*stw2

      dfen = (ven-aen)/aen
      dfel = (vel-ael)/ael
      dfup = (vup-aup)/aup
      dfdn = (vdn-adn)/adn
      dfmn = (vmn-amn)/amn
      dfmo = (vmo-amo)/amo
      dfch = (vch-ach)/ach
      dfst = (vst-ast)/ast
      dftn = (vtn-atn)/atn
      dfta = (vta-ata)/ata
      dftp = (vtp-atp)/atp
      dfbt = (vbt-abt)/abt

      vpaen = ven+aen
      vmaen = ven-aen
      vpael = vel+ael
      vmael = vel-ael
      vpaup = vup+aup
      vmaup = vup-aup
      vpadn = vdn+adn
      vmadn = vdn-adn
      vpamn = vmn+amn
      vmamn = vmn-amn
      vpamo = vmo+amo
      vmamo = vmo-amo
      vpach = vch+ach
      vmach = vch-ach
      vpast = vst+ast
      vmast = vst-ast
      vpatn = vtn+atn
      vmatn = vtn-atn
      vpata = vta+ata
      vmata = vta-ata
      vpatp = vtp+atp
      vmatp = vtp-atp
      vpabt = vbt+abt
      vmabt = vbt-abt

      gz    = mz*wz
      mz2   = qcmplx(rzm2,-gz)
      mz2c  = qconjg(mz2)
      gw    = mw*ww
      mw2   = qcmplx(rwm2,-gw)
      mw2c  = qconjg(mw2)
      gh    = mh*wh
      mh2   = qcmplx(rhm2,-gh)
      mh2c  = qconjg(mh2)
      gtp   = mtp*wtp
      mtp2  = qcmplx(rtpm2,-gtp)
      mtp2c = qconjg(mtp2)

      gf_gf = gf
      gf = pi/alphai/sqrt(2q0)/stw2/ctw2/rzm2      
      cfscheme = gf/gf_gf
      if (gfscheme.eq.0) then
         cfscheme = 1q0
         print *, "Alpha scheme"
      elseif (gfscheme.eq.1) then
         gf = gf_gf
         print *, "GFermi scheme"
      elseif (gfscheme.eq.2) then
         gf = gf_gf
         alphai = pi/gf/sqrt(2q0)/stw2/ctw2/rzm2
         print *, "GFermi prime scheme"
      endif
      alpha = 1q0/alphai
      e = sqrt(4q0*pi*alpha)
      g = sqrt(gf/sr2*8q0*rzm2*ctw2)
      gs = sqrt(4q0*pi*alphas)

      return
      end
